# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import io
import re  # noqa: F401
import warnings
from typing import Optional

from getopenpay.api_client import ApiClient
from getopenpay.api_response import ApiResponse
from getopenpay.exceptions import ApiTypeError, ApiValueError  # noqa: F401
from getopenpay.models.create_price_request import CreatePriceRequest
from getopenpay.models.delete_price_response import DeletePriceResponse
from getopenpay.models.list_response_price_external import ListResponsePriceExternal
from getopenpay.models.price_external import PriceExternal
from getopenpay.models.price_query_params import PriceQueryParams
from getopenpay.models.search_price_request import SearchPriceRequest
from getopenpay.models.update_price_request import UpdatePriceRequest
from pydantic import Field, StrictStr, ValidationError, conlist, validate_arguments
from typing_extensions import Annotated


class PricesApi:
  """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

  def __init__(self, api_client=None) -> None:
    if api_client is None:
      api_client = ApiClient.get_default()
    self.api_client = api_client

  @validate_arguments
  def create_price_for_product(
    self, create_price_request: CreatePriceRequest, **kwargs
  ) -> PriceExternal:  # noqa: E501
    """Create Price For Product  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_price_for_product(create_price_request, async_req=True)
        >>> result = thread.get()

        :param create_price_request: (required)
        :type create_price_request: CreatePriceRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PriceExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the create_price_for_product_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.create_price_for_product_with_http_info(
      create_price_request, **kwargs
    )  # noqa: E501

  @validate_arguments
  def create_price_for_product_with_http_info(
    self, create_price_request: CreatePriceRequest, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Create Price For Product  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_price_for_product_with_http_info(create_price_request, async_req=True)
        >>> result = thread.get()

        :param create_price_request: (required)
        :type create_price_request: CreatePriceRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PriceExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['create_price_request']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method create_price_for_product' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['create_price_request'] is not None:
      _body_params = _params['create_price_request']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '201': 'PriceExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/prices/',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def delete_price_for_product(
    self, price_id: Annotated[StrictStr,
                              Field(..., description='Unique identifier of the price.')], **kwargs
  ) -> DeletePriceResponse:  # noqa: E501
    """Delete Price For Product  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_price_for_product(price_id, async_req=True)
        >>> result = thread.get()

        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: DeletePriceResponse
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the delete_price_for_product_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.delete_price_for_product_with_http_info(price_id, **kwargs)  # noqa: E501

  @validate_arguments
  def delete_price_for_product_with_http_info(
    self, price_id: Annotated[StrictStr,
                              Field(..., description='Unique identifier of the price.')], **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Delete Price For Product  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_price_for_product_with_http_info(price_id, async_req=True)
        >>> result = thread.get()

        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(DeletePriceResponse, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['price_id']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method delete_price_for_product' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}
    if _params['price_id'] is not None:
      _path_params['price_id'] = _params['price_id']

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'DeletePriceResponse',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/prices/{price_id}',
      'DELETE',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def get_price_for_product(
    self,
    price_id: Annotated[StrictStr,
                        Field(..., description='Unique identifier of the price.')],
    expand: Optional[conlist(StrictStr)] = None,
    **kwargs
  ) -> PriceExternal:  # noqa: E501
    """Get Price For Product  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_price_for_product(price_id, expand, async_req=True)
        >>> result = thread.get()

        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param expand:
        :type expand: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PriceExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the get_price_for_product_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.get_price_for_product_with_http_info(price_id, expand, **kwargs)  # noqa: E501

  @validate_arguments
  def get_price_for_product_with_http_info(
    self,
    price_id: Annotated[StrictStr,
                        Field(..., description='Unique identifier of the price.')],
    expand: Optional[conlist(StrictStr)] = None,
    **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Get Price For Product  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_price_for_product_with_http_info(price_id, expand, async_req=True)
        >>> result = thread.get()

        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param expand:
        :type expand: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PriceExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['price_id', 'expand']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method get_price_for_product' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}
    if _params['price_id'] is not None:
      _path_params['price_id'] = _params['price_id']

    # process the query parameters
    _query_params = []
    if _params.get('expand') is not None:  # noqa: E501
      _query_params.append(('expand', _params['expand']))
      _collection_formats['expand'] = 'multi'

    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'PriceExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/prices/{price_id}',
      'GET',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def list_prices(
    self, price_query_params: PriceQueryParams, **kwargs
  ) -> ListResponsePriceExternal:  # noqa: E501
    """List Prices  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_prices(price_query_params, async_req=True)
        >>> result = thread.get()

        :param price_query_params: (required)
        :type price_query_params: PriceQueryParams
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ListResponsePriceExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the list_prices_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.list_prices_with_http_info(price_query_params, **kwargs)  # noqa: E501

  @validate_arguments
  def list_prices_with_http_info(
    self, price_query_params: PriceQueryParams, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """List Prices  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_prices_with_http_info(price_query_params, async_req=True)
        >>> result = thread.get()

        :param price_query_params: (required)
        :type price_query_params: PriceQueryParams
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ListResponsePriceExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['price_query_params']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method list_prices' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['price_query_params'] is not None:
      _body_params = _params['price_query_params']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'ListResponsePriceExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/prices/list',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def search_prices(
    self, search_price_request: SearchPriceRequest, **kwargs
  ) -> ListResponsePriceExternal:  # noqa: E501
    """Search Prices  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.search_prices(search_price_request, async_req=True)
        >>> result = thread.get()

        :param search_price_request: (required)
        :type search_price_request: SearchPriceRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ListResponsePriceExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the search_prices_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.search_prices_with_http_info(search_price_request, **kwargs)  # noqa: E501

  @validate_arguments
  def search_prices_with_http_info(
    self, search_price_request: SearchPriceRequest, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Search Prices  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.search_prices_with_http_info(search_price_request, async_req=True)
        >>> result = thread.get()

        :param search_price_request: (required)
        :type search_price_request: SearchPriceRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ListResponsePriceExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['search_price_request']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method search_prices' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['search_price_request'] is not None:
      _body_params = _params['search_price_request']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'ListResponsePriceExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/prices/search',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def update_price_for_product(
    self, price_id: Annotated[StrictStr,
                              Field(..., description='Unique identifier of the price.')],
    update_price_request: UpdatePriceRequest, **kwargs
  ) -> PriceExternal:  # noqa: E501
    """Update Price For Product  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_price_for_product(price_id, update_price_request, async_req=True)
        >>> result = thread.get()

        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param update_price_request: (required)
        :type update_price_request: UpdatePriceRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PriceExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the update_price_for_product_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.update_price_for_product_with_http_info(
      price_id, update_price_request, **kwargs
    )  # noqa: E501

  @validate_arguments
  def update_price_for_product_with_http_info(
    self, price_id: Annotated[StrictStr,
                              Field(..., description='Unique identifier of the price.')],
    update_price_request: UpdatePriceRequest, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Update Price For Product  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_price_for_product_with_http_info(price_id, update_price_request, async_req=True)
        >>> result = thread.get()

        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param update_price_request: (required)
        :type update_price_request: UpdatePriceRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PriceExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['price_id', 'update_price_request']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method update_price_for_product' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}
    if _params['price_id'] is not None:
      _path_params['price_id'] = _params['price_id']

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['update_price_request'] is not None:
      _body_params = _params['update_price_request']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'PriceExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/prices/{price_id}',
      'PUT',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )
