# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Optional

from getopenpay.models.invite_status_enum import InviteStatusEnum
from getopenpay.models.object_name import ObjectName
from getopenpay.models.role_enum import RoleEnum
from pydantic import BaseModel, Field, StrictBool, StrictStr


class InviteExternal(BaseModel):
  """
    InviteExternal
    """
  id: StrictStr = Field(..., description='Unique Identifier of the account.')
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  email: StrictStr = Field(..., description='Email of the user.')
  role: RoleEnum = Field(...)
  account_id: StrictStr = Field(..., description='Unique Identifier of the account.')
  account_name: StrictStr = Field(..., description='Account name to which user is invited.')
  status: InviteStatusEnum = Field(...)
  __properties = [
    'id', 'object', 'created_at', 'updated_at', 'is_deleted', 'email', 'role', 'account_id',
    'account_name', 'status'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> InviteExternal:
    """Create an instance of InviteExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> InviteExternal:
    """Create an instance of InviteExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return InviteExternal.parse_obj(obj)

    _obj = InviteExternal.parse_obj(
      {
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'email': obj.get('email'),
        'role': obj.get('role'),
        'account_id': obj.get('account_id'),
        'account_name': obj.get('account_name'),
        'status': obj.get('status')
      }
    )
    return _obj
