# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, Dict, Optional

from getopenpay.models.complete_address import CompleteAddress
from getopenpay.models.object_name import ObjectName
from getopenpay.models.payment_provider_type import PaymentProviderType
from pydantic import BaseModel, Field, StrictBool, StrictStr


class PaymentMethodExternal(BaseModel):
  """
    PaymentMethodExternal
    """
  id: StrictStr = Field(..., description='Unique Identifier of the payment_method.')
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  customer_id: Optional[StrictStr] = None
  billing_address: Optional[CompleteAddress] = None
  metadata: Optional[Dict[str, Any]] = None
  provider: PaymentProviderType = Field(...)
  card_type: Optional[StrictStr] = None
  last_four: Optional[StrictStr] = None
  __properties = [
    'id', 'object', 'created_at', 'updated_at', 'is_deleted', 'customer_id', 'billing_address',
    'metadata', 'provider', 'card_type', 'last_four'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> PaymentMethodExternal:
    """Create an instance of PaymentMethodExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # override the default output from pydantic by calling `to_dict()` of billing_address
    if self.billing_address:
      _dict['billing_address'] = self.billing_address.to_dict()
    # set to None if customer_id (nullable) is None
    # and __fields_set__ contains the field
    if self.customer_id is None and 'customer_id' in self.__fields_set__:
      _dict['customer_id'] = None

    # set to None if billing_address (nullable) is None
    # and __fields_set__ contains the field
    if self.billing_address is None and 'billing_address' in self.__fields_set__:
      _dict['billing_address'] = None

    # set to None if metadata (nullable) is None
    # and __fields_set__ contains the field
    if self.metadata is None and 'metadata' in self.__fields_set__:
      _dict['metadata'] = None

    # set to None if card_type (nullable) is None
    # and __fields_set__ contains the field
    if self.card_type is None and 'card_type' in self.__fields_set__:
      _dict['card_type'] = None

    # set to None if last_four (nullable) is None
    # and __fields_set__ contains the field
    if self.last_four is None and 'last_four' in self.__fields_set__:
      _dict['last_four'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> PaymentMethodExternal:
    """Create an instance of PaymentMethodExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return PaymentMethodExternal.parse_obj(obj)

    _obj = PaymentMethodExternal.parse_obj(
      {
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'customer_id': obj.get('customer_id'),
        'billing_address':
          CompleteAddress.from_dict(obj.get('billing_address'))
          if obj.get('billing_address') is not None else None,
        'metadata': obj.get('metadata'),
        'provider': obj.get('provider'),
        'card_type': obj.get('card_type'),
        'last_four': obj.get('last_four')
      }
    )
    return _obj
