# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, Dict, List, Optional

from getopenpay.models.coupon_external import CouponExternal
from getopenpay.models.object_name import ObjectName
from getopenpay.models.promo_restrictions import PromoRestrictions
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist


class PromotionCodeExternal(BaseModel):
  """
    PromotionCodeExternal
    """
  id: StrictStr = Field(...)
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  code: StrictStr = Field(...)
  is_active: StrictBool = Field(...)
  coupon_id: StrictStr = Field(...)
  coupon: CouponExternal = Field(...)
  customer_ids: Optional[conlist(StrictStr)] = None
  expires_at: Optional[datetime] = None
  max_redemptions: Optional[StrictInt] = None
  times_redeemed: Optional[StrictInt] = None
  max_redemptions_per_customer: Optional[StrictInt] = None
  restrictions: Optional[PromoRestrictions] = Field(...)
  metadata: Optional[Dict[str, Any]] = None
  __properties = [
    'id', 'object', 'created_at', 'updated_at', 'is_deleted', 'code', 'is_active', 'coupon_id',
    'coupon', 'customer_ids', 'expires_at', 'max_redemptions', 'times_redeemed',
    'max_redemptions_per_customer', 'restrictions', 'metadata'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> PromotionCodeExternal:
    """Create an instance of PromotionCodeExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # override the default output from pydantic by calling `to_dict()` of coupon
    if self.coupon:
      _dict['coupon'] = self.coupon.to_dict()
    # override the default output from pydantic by calling `to_dict()` of restrictions
    if self.restrictions:
      _dict['restrictions'] = self.restrictions.to_dict()
    # set to None if expires_at (nullable) is None
    # and __fields_set__ contains the field
    if self.expires_at is None and 'expires_at' in self.__fields_set__:
      _dict['expires_at'] = None

    # set to None if max_redemptions (nullable) is None
    # and __fields_set__ contains the field
    if self.max_redemptions is None and 'max_redemptions' in self.__fields_set__:
      _dict['max_redemptions'] = None

    # set to None if times_redeemed (nullable) is None
    # and __fields_set__ contains the field
    if self.times_redeemed is None and 'times_redeemed' in self.__fields_set__:
      _dict['times_redeemed'] = None

    # set to None if max_redemptions_per_customer (nullable) is None
    # and __fields_set__ contains the field
    if self.max_redemptions_per_customer is None and 'max_redemptions_per_customer' in self.__fields_set__:
      _dict['max_redemptions_per_customer'] = None

    # set to None if restrictions (nullable) is None
    # and __fields_set__ contains the field
    if self.restrictions is None and 'restrictions' in self.__fields_set__:
      _dict['restrictions'] = None

    # set to None if metadata (nullable) is None
    # and __fields_set__ contains the field
    if self.metadata is None and 'metadata' in self.__fields_set__:
      _dict['metadata'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> PromotionCodeExternal:
    """Create an instance of PromotionCodeExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return PromotionCodeExternal.parse_obj(obj)

    _obj = PromotionCodeExternal.parse_obj(
      {
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'code': obj.get('code'),
        'is_active': obj.get('is_active'),
        'coupon_id': obj.get('coupon_id'),
        'coupon':
          CouponExternal.from_dict(obj.get('coupon')) if obj.get('coupon') is not None else None,
        'customer_ids': obj.get('customer_ids'),
        'expires_at': obj.get('expires_at'),
        'max_redemptions': obj.get('max_redemptions'),
        'times_redeemed': obj.get('times_redeemed'),
        'max_redemptions_per_customer': obj.get('max_redemptions_per_customer'),
        'restrictions':
          PromoRestrictions.from_dict(obj.get('restrictions'))
          if obj.get('restrictions') is not None else None,
        'metadata': obj.get('metadata')
      }
    )
    return _obj
