# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Optional

from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, Field, StrictBool, StrictStr


class TransitionEligibilityExternal(BaseModel):
  """
    TransitionEligibilityExternal
    """
  id: StrictStr = Field(..., description='Unique Identifier of the transition eligibility.')
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: StrictBool = Field(
    ..., description='Flag to indicate whether the transition rule has been deleted or not'
  )
  current_price_id: Optional[StrictStr] = Field(...)
  target_price_id: Optional[StrictStr] = Field(...)
  current_product_id: Optional[StrictStr] = Field(...)
  target_product_id: Optional[StrictStr] = Field(...)
  __properties = [
    'id', 'object', 'created_at', 'updated_at', 'is_deleted', 'current_price_id', 'target_price_id',
    'current_product_id', 'target_product_id'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> TransitionEligibilityExternal:
    """Create an instance of TransitionEligibilityExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if current_price_id (nullable) is None
    # and __fields_set__ contains the field
    if self.current_price_id is None and 'current_price_id' in self.__fields_set__:
      _dict['current_price_id'] = None

    # set to None if target_price_id (nullable) is None
    # and __fields_set__ contains the field
    if self.target_price_id is None and 'target_price_id' in self.__fields_set__:
      _dict['target_price_id'] = None

    # set to None if current_product_id (nullable) is None
    # and __fields_set__ contains the field
    if self.current_product_id is None and 'current_product_id' in self.__fields_set__:
      _dict['current_product_id'] = None

    # set to None if target_product_id (nullable) is None
    # and __fields_set__ contains the field
    if self.target_product_id is None and 'target_product_id' in self.__fields_set__:
      _dict['target_product_id'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> TransitionEligibilityExternal:
    """Create an instance of TransitionEligibilityExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return TransitionEligibilityExternal.parse_obj(obj)

    _obj = TransitionEligibilityExternal.parse_obj(
      {
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted'),
        'current_price_id': obj.get('current_price_id'),
        'target_price_id': obj.get('target_price_id'),
        'current_product_id': obj.get('current_product_id'),
        'target_product_id': obj.get('target_product_id')
      }
    )
    return _obj
